import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewChild, Input, Output, NgModule } from '@angular/core';

class AngularCanvasService {
    constructor() { }
}
AngularCanvasService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
AngularCanvasService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class SignPadComponent {
    constructor() {
        this.isDrawing = false;
        this.onSaveImage = new EventEmitter();
    }
    ngAfterViewInit() {
        this.context = this.signatureCanvas.nativeElement.getContext('2d');
        this.context.lineWidth = 2;
        this.context.lineCap = 'round';
        this.signatureCanvas.nativeElement.addEventListener('mousedown', this.onTouchStart.bind(this));
        this.signatureCanvas.nativeElement.addEventListener('mousemove', this.onTouchMove.bind(this));
        this.signatureCanvas.nativeElement.addEventListener('mouseup', this.onTouchEnd.bind(this));
        this.signatureCanvas.nativeElement.addEventListener('touchstart', this.onTouchStart.bind(this));
        this.signatureCanvas.nativeElement.addEventListener('touchmove', this.onTouchMove.bind(this));
        this.signatureCanvas.nativeElement.addEventListener('touchend', this.onTouchEnd.bind(this));
    }
    clearSignature() {
        this.context.clearRect(0, 0, this.signatureCanvas.nativeElement.width, this.signatureCanvas.nativeElement.height);
    }
    saveSignature() {
        let trimmedCanvas = this.trimCanvas(this.signatureCanvas.nativeElement);
        this.onSaveImage.emit(trimmedCanvas.toDataURL());
    }
    onTouchStart(event) {
        this.isDrawing = true;
        this.context.beginPath();
        this.updateCoordinates(event);
    }
    onTouchMove(event) {
        if (!this.isDrawing)
            return;
        this.updateCoordinates(event);
        this.context.lineTo(this.clientX, this.clientY);
        this.context.stroke();
    }
    onTouchEnd() {
        this.isDrawing = false;
        this.context.closePath();
    }
    updateCoordinates(event) {
        if (event instanceof MouseEvent) {
            this.clientX = event.clientX - this.signatureCanvas.nativeElement.offsetLeft;
            this.clientY = event.clientY - this.signatureCanvas.nativeElement.offsetTop;
        }
        else if (event instanceof TouchEvent) {
            this.clientX = event.touches[0].clientX - this.signatureCanvas.nativeElement.offsetLeft;
            this.clientY = event.touches[0].clientY - this.signatureCanvas.nativeElement.offsetTop;
        }
    }
    trimCanvas(c) {
        let ctx = c.getContext('2d'), copy = document.createElement('canvas').getContext('2d'), pixels = ctx.getImageData(0, 0, c.width, c.height), l = pixels.data.length, i, bound = {
            top: c.height,
            left: c.width,
            right: 0,
            bottom: 0
        }, x, y;
        for (i = 0; i < l; i += 4) {
            if (pixels.data[i + 3] !== 0) {
                x = (i / 4) % c.width;
                y = ~~((i / 4) / c.width);
                if (bound.top === c.height) {
                    bound.top = y;
                }
                else if (y < bound.top) {
                    bound.top = y;
                }
                if (x > bound.right) {
                    bound.right = x;
                }
                if (x < bound.left) {
                    bound.left = x;
                }
                if (bound.bottom < y) {
                    bound.bottom = y;
                }
            }
        }
        let trimHeight = bound.bottom - bound.top, trimWidth = bound.right - bound.left, trimmed = ctx.getImageData(bound.left, bound.top, trimWidth, trimHeight);
        copy.canvas.width = trimWidth;
        copy.canvas.height = trimHeight;
        copy.putImageData(trimmed, 0, 0);
        return copy.canvas;
    }
}
SignPadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: SignPadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SignPadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: SignPadComponent, selector: "lib-sign-pad", inputs: { hgt: "hgt", wdt: "wdt", canvasSpecs: "canvasSpecs" }, outputs: { onSaveImage: "onSaveImage" }, viewQueries: [{ propertyName: "signatureCanvas", first: true, predicate: ["signatureCanvas"], descendants: true, static: true }], ngImport: i0, template: "<div > \n    <canvas #signatureCanvas [width]=\"wdt ? wdt : '800'\" [height]=\"hgt ? hgt : '200'\" style=\"border:1px dashed #696969;background-color: rgb(235, 235, 235);\"></canvas>\n    <div>\n        <button (click)=\"clearSignature()\">Clear</button>\n        <button (click)=\"saveSignature()\">Save</button>\n    </div>\n</div>\n  <!--  position: relative;\nstyle=\"position: absolute;\"\n-->", styles: ["div{text-align:center;margin-top:20px}canvas{border:1px solid #000;cursor:crosshair}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: SignPadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-sign-pad', template: "<div > \n    <canvas #signatureCanvas [width]=\"wdt ? wdt : '800'\" [height]=\"hgt ? hgt : '200'\" style=\"border:1px dashed #696969;background-color: rgb(235, 235, 235);\"></canvas>\n    <div>\n        <button (click)=\"clearSignature()\">Clear</button>\n        <button (click)=\"saveSignature()\">Save</button>\n    </div>\n</div>\n  <!--  position: relative;\nstyle=\"position: absolute;\"\n-->", styles: ["div{text-align:center;margin-top:20px}canvas{border:1px solid #000;cursor:crosshair}\n"] }]
        }], propDecorators: { signatureCanvas: [{
                type: ViewChild,
                args: ['signatureCanvas', { static: true }]
            }], hgt: [{
                type: Input
            }], wdt: [{
                type: Input
            }], canvasSpecs: [{
                type: Input
            }], onSaveImage: [{
                type: Output
            }] } });

class AngularCanvasComponent {
    constructor() {
        this.exportImg = new EventEmitter();
    }
    onSaveImage(eve) {
        console.log('eve: ', eve);
        this.exportImg.emit(eve);
    }
}
AngularCanvasComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AngularCanvasComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: AngularCanvasComponent, selector: "lib-angular-canvas", inputs: { hgt: "hgt", wdt: "wdt" }, outputs: { exportImg: "exportImg" }, ngImport: i0, template: `
  <h3></h3>
    <lib-sign-pad [hgt]="hgt" [wdt]="wdt" (onSaveImage)="onSaveImage($event)"></lib-sign-pad>
  `, isInline: true, dependencies: [{ kind: "component", type: SignPadComponent, selector: "lib-sign-pad", inputs: ["hgt", "wdt", "canvasSpecs"], outputs: ["onSaveImage"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-angular-canvas', template: `
  <h3></h3>
    <lib-sign-pad [hgt]="hgt" [wdt]="wdt" (onSaveImage)="onSaveImage($event)"></lib-sign-pad>
  ` }]
        }], propDecorators: { hgt: [{
                type: Input
            }], wdt: [{
                type: Input
            }], exportImg: [{
                type: Output
            }] } });

class AngularCanvasModule {
}
AngularCanvasModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AngularCanvasModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasModule, declarations: [AngularCanvasComponent,
        SignPadComponent], exports: [AngularCanvasComponent,
        SignPadComponent] });
AngularCanvasModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularCanvasModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AngularCanvasComponent,
                        SignPadComponent
                    ],
                    imports: [],
                    exports: [
                        AngularCanvasComponent,
                        SignPadComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of angular-canvas
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AngularCanvasComponent, AngularCanvasModule, AngularCanvasService, SignPadComponent };
//# sourceMappingURL=e-signature-ng-signature-pad.mjs.map
